Update an LLM Observability prompt

Note: This endpoint is in preview and is subject to change. If you have any feedback, contact Datadog support.

PATCH https://api.ap1.datadoghq.com/api/v2/llm-obs/v1/prompts/{prompt_id}https://api.ap2.datadoghq.com/api/v2/llm-obs/v1/prompts/{prompt_id}https://api.datadoghq.eu/api/v2/llm-obs/v1/prompts/{prompt_id}https://api.ddog-gov.com/api/v2/llm-obs/v1/prompts/{prompt_id}https://api.us2.ddog-gov.com/api/v2/llm-obs/v1/prompts/{prompt_id}https://api.uk1.datadoghq.com/api/v2/llm-obs/v1/prompts/{prompt_id}https://api.datadoghq.com/api/v2/llm-obs/v1/prompts/{prompt_id}https://api.us3.datadoghq.com/api/v2/llm-obs/v1/prompts/{prompt_id}https://api.us5.datadoghq.com/api/v2/llm-obs/v1/prompts/{prompt_id}

Overview

Update the title, the description, or both, for an LLM Observability prompt. This endpoint requires all of the following permissions:

  • llm_observability_read
  • llm_observability_write
  • feature_flag_config_read
  • feature_flag_config_write
  • feature_flag_environment_config_read

  • Arguments

    Path Parameters

    Name

    Type

    Description

    prompt_id [required]

    string

    The customer-provided identifier of the LLM Observability prompt.

    Request

    Body Data (required)

    Update prompt payload.

    Expand All

    Field

    Type

    Description

    data [required]

    object

    Data object for updating an LLM Observability prompt.

    attributes [required]

    object

    Attributes for updating an LLM Observability prompt. At least one of title or description must be provided; both attributes are optional individually.

    description

    string

    Optional new description for the prompt.

    title

    string

    Optional new title for the prompt.

    type [required]

    enum

    Resource type of an LLM Observability prompt. Allowed enum values: prompt-templates

    {
      "data": {
        "attributes": {
          "title": "Customer Support Assistant"
        },
        "type": "prompt-templates"
      }
    }

    Response

    OK

    Response containing a single LLM Observability prompt.

    Expand All

    Field

    Type

    Description

    data [required]

    object

    Data object for an LLM Observability prompt.

    attributes [required]

    object

    Attributes of an LLM Observability prompt registry entry.

    author

    string

    UUID of the user who authored the prompt.

    created_at

    date-time

    Timestamp when the prompt was created.

    created_from [required]

    string

    Source that created the prompt, such as ui-registry, sdk-registry, or sdk-instrumentation.

    datasets

    [object]

    Datasets observed in runs associated with this prompt.

    id [required]

    string

    Unique identifier of the dataset.

    name

    string

    Name of the dataset.

    description

    string

    Description of the prompt.

    extracted_from

    string

    Source prompt from which this prompt was extracted, when applicable.

    in_registry [required]

    boolean

    Whether the prompt is a registry entry (as opposed to a code-discovered prompt).

    last_seen_at

    date-time

    Timestamp of the most recent observed run of this prompt.

    last_version_created_at

    date-time

    Timestamp when the most recent version of the prompt was created.

    ml_app

    string

    The ML application this prompt is associated with.

    ml_apps

    [string]

    ML applications observed running this prompt.

    num_versions [required]

    int64

    Number of versions of the prompt.

    prompt_id [required]

    string

    Customer-provided identifier of the prompt.

    source [required]

    enum

    Whether the prompt was created from the registry or discovered from observed LLM calls. Allowed enum values: registry,code

    tags

    [string]

    Tags observed on runs of this prompt.

    title

    string

    Title of the prompt.

    id [required]

    string

    Unique identifier of the prompt.

    type [required]

    enum

    Resource type of an LLM Observability prompt. Allowed enum values: prompt-templates

    {
      "data": {
        "attributes": {
          "author": "3b12f1df-14fd-4e12-bd6f-4a2f5c8b3d1e",
          "created_at": "2025-01-15T10:00:00Z",
          "created_from": "sdk-registry",
          "description": "Answers customer questions using the company knowledge base.",
          "in_registry": true,
          "last_version_created_at": "2025-01-15T10:00:00Z",
          "num_versions": 1,
          "prompt_id": "customer-support-assistant",
          "source": "registry",
          "title": "Customer Support Assistant"
        },
        "id": "4a1a28ff-8a25-5f0f-946f-f48264d772eb",
        "type": "prompt-templates"
      }
    }

    Bad Request

    API error response.

    Expand All

    Field

    Type

    Description

    errors [required]

    [object]

    A list of errors.

    detail

    string

    A human-readable explanation specific to this occurrence of the error.

    meta

    object

    Non-standard meta-information about the error

    source

    object

    References to the source of the error.

    header

    string

    A string indicating the name of a single request header which caused the error.

    parameter

    string

    A string indicating which URI query parameter caused the error.

    pointer

    string

    A JSON pointer to the value in the request document that caused the error.

    status

    string

    Status code of the response.

    title

    string

    Short human-readable summary of the error.

    {
      "errors": [
        {
          "detail": "Missing required attribute in body",
          "meta": {},
          "source": {
            "header": "Authorization",
            "parameter": "limit",
            "pointer": "/data/attributes/title"
          },
          "status": "400",
          "title": "Bad Request"
        }
      ]
    }

    Unauthorized

    API error response.

    Expand All

    Field

    Type

    Description

    errors [required]

    [object]

    A list of errors.

    detail

    string

    A human-readable explanation specific to this occurrence of the error.

    meta

    object

    Non-standard meta-information about the error

    source

    object

    References to the source of the error.

    header

    string

    A string indicating the name of a single request header which caused the error.

    parameter

    string

    A string indicating which URI query parameter caused the error.

    pointer

    string

    A JSON pointer to the value in the request document that caused the error.

    status

    string

    Status code of the response.

    title

    string

    Short human-readable summary of the error.

    {
      "errors": [
        {
          "detail": "Missing required attribute in body",
          "meta": {},
          "source": {
            "header": "Authorization",
            "parameter": "limit",
            "pointer": "/data/attributes/title"
          },
          "status": "400",
          "title": "Bad Request"
        }
      ]
    }

    Forbidden

    API error response.

    Expand All

    Field

    Type

    Description

    errors [required]

    [object]

    A list of errors.

    detail

    string

    A human-readable explanation specific to this occurrence of the error.

    meta

    object

    Non-standard meta-information about the error

    source

    object

    References to the source of the error.

    header

    string

    A string indicating the name of a single request header which caused the error.

    parameter

    string

    A string indicating which URI query parameter caused the error.

    pointer

    string

    A JSON pointer to the value in the request document that caused the error.

    status

    string

    Status code of the response.

    title

    string

    Short human-readable summary of the error.

    {
      "errors": [
        {
          "detail": "Missing required attribute in body",
          "meta": {},
          "source": {
            "header": "Authorization",
            "parameter": "limit",
            "pointer": "/data/attributes/title"
          },
          "status": "400",
          "title": "Bad Request"
        }
      ]
    }

    Not Found

    API error response.

    Expand All

    Field

    Type

    Description

    errors [required]

    [object]

    A list of errors.

    detail

    string

    A human-readable explanation specific to this occurrence of the error.

    meta

    object

    Non-standard meta-information about the error

    source

    object

    References to the source of the error.

    header

    string

    A string indicating the name of a single request header which caused the error.

    parameter

    string

    A string indicating which URI query parameter caused the error.

    pointer

    string

    A JSON pointer to the value in the request document that caused the error.

    status

    string

    Status code of the response.

    title

    string

    Short human-readable summary of the error.

    {
      "errors": [
        {
          "detail": "Missing required attribute in body",
          "meta": {},
          "source": {
            "header": "Authorization",
            "parameter": "limit",
            "pointer": "/data/attributes/title"
          },
          "status": "400",
          "title": "Bad Request"
        }
      ]
    }

    Too many requests

    API error response.

    Expand All

    Field

    Type

    Description

    errors [required]

    [string]

    A list of errors.

    {
      "errors": [
        "Bad Request"
      ]
    }

    Code Example

                              ## default
    # 
    
    # Path parameters
    export prompt_id="customer-support-assistant"
    # Curl command
    curl -X PATCH "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/llm-obs/v1/prompts/${prompt_id}" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "DD-API-KEY: ${DD_API_KEY}" \ -H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \ -d @- << EOF { "data": { "attributes": { "description": "Answers customer questions using the company knowledge base.", "title": "Customer Support Assistant" }, "type": "prompt-templates" } } EOF
    // Update an LLM Observability prompt returns "OK" response
    
    package main
    
    import (
    	"context"
    	"encoding/json"
    	"fmt"
    	"os"
    
    	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
    	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
    )
    
    func main() {
    	// there is a valid "prompt" in the system
    	PromptDataAttributesPromptID := os.Getenv("PROMPT_DATA_ATTRIBUTES_PROMPT_ID")
    
    	body := datadogV2.LLMObsUpdatePromptRequest{
    		Data: datadogV2.LLMObsUpdatePromptData{
    			Attributes: datadogV2.LLMObsUpdatePromptDataAttributes{
    				Title: datadog.PtrString("Customer Support Assistant"),
    			},
    			Type: datadogV2.LLMOBSPROMPTTYPE_PROMPT_TEMPLATES,
    		},
    	}
    	ctx := datadog.NewDefaultContext(context.Background())
    	configuration := datadog.NewConfiguration()
    	configuration.SetUnstableOperationEnabled("v2.UpdateLLMObsPrompt", true)
    	apiClient := datadog.NewAPIClient(configuration)
    	api := datadogV2.NewLLMObservabilityApi(apiClient)
    	resp, r, err := api.UpdateLLMObsPrompt(ctx, PromptDataAttributesPromptID, body)
    
    	if err != nil {
    		fmt.Fprintf(os.Stderr, "Error when calling `LLMObservabilityApi.UpdateLLMObsPrompt`: %v\n", err)
    		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
    	}
    
    	responseContent, _ := json.MarshalIndent(resp, "", "  ")
    	fmt.Fprintf(os.Stdout, "Response from `LLMObservabilityApi.UpdateLLMObsPrompt`:\n%s\n", responseContent)
    }
    

    Instructions

    First install the library and its dependencies and then save the example to main.go and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
    // Update an LLM Observability prompt returns "OK" response
    
    import com.datadog.api.client.ApiClient;
    import com.datadog.api.client.ApiException;
    import com.datadog.api.client.v2.api.LlmObservabilityApi;
    import com.datadog.api.client.v2.model.LLMObsPromptResponse;
    import com.datadog.api.client.v2.model.LLMObsPromptType;
    import com.datadog.api.client.v2.model.LLMObsUpdatePromptData;
    import com.datadog.api.client.v2.model.LLMObsUpdatePromptDataAttributes;
    import com.datadog.api.client.v2.model.LLMObsUpdatePromptRequest;
    
    public class Example {
      public static void main(String[] args) {
        ApiClient defaultClient = ApiClient.getDefaultApiClient();
        defaultClient.setUnstableOperationEnabled("v2.updateLLMObsPrompt", true);
        LlmObservabilityApi apiInstance = new LlmObservabilityApi(defaultClient);
    
        // there is a valid "prompt" in the system
        String PROMPT_DATA_ATTRIBUTES_PROMPT_ID = System.getenv("PROMPT_DATA_ATTRIBUTES_PROMPT_ID");
    
        LLMObsUpdatePromptRequest body =
            new LLMObsUpdatePromptRequest()
                .data(
                    new LLMObsUpdatePromptData()
                        .attributes(
                            new LLMObsUpdatePromptDataAttributes().title("Customer Support Assistant"))
                        .type(LLMObsPromptType.PROMPT_TEMPLATES));
    
        try {
          LLMObsPromptResponse result =
              apiInstance.updateLLMObsPrompt(PROMPT_DATA_ATTRIBUTES_PROMPT_ID, body);
          System.out.println(result);
        } catch (ApiException e) {
          System.err.println("Exception when calling LlmObservabilityApi#updateLLMObsPrompt");
          System.err.println("Status code: " + e.getCode());
          System.err.println("Reason: " + e.getResponseBody());
          System.err.println("Response headers: " + e.getResponseHeaders());
          e.printStackTrace();
        }
      }
    }
    

    Instructions

    First install the library and its dependencies and then save the example to Example.java and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
    """
    Update an LLM Observability prompt returns "OK" response
    """
    
    from os import environ
    from datadog_api_client import ApiClient, Configuration
    from datadog_api_client.v2.api.llm_observability_api import LLMObservabilityApi
    from datadog_api_client.v2.model.llm_obs_prompt_type import LLMObsPromptType
    from datadog_api_client.v2.model.llm_obs_update_prompt_data import LLMObsUpdatePromptData
    from datadog_api_client.v2.model.llm_obs_update_prompt_data_attributes import LLMObsUpdatePromptDataAttributes
    from datadog_api_client.v2.model.llm_obs_update_prompt_request import LLMObsUpdatePromptRequest
    
    # there is a valid "prompt" in the system
    PROMPT_DATA_ATTRIBUTES_PROMPT_ID = environ["PROMPT_DATA_ATTRIBUTES_PROMPT_ID"]
    
    body = LLMObsUpdatePromptRequest(
        data=LLMObsUpdatePromptData(
            attributes=LLMObsUpdatePromptDataAttributes(
                title="Customer Support Assistant",
            ),
            type=LLMObsPromptType.PROMPT_TEMPLATES,
        ),
    )
    
    configuration = Configuration()
    configuration.unstable_operations["update_llm_obs_prompt"] = True
    with ApiClient(configuration) as api_client:
        api_instance = LLMObservabilityApi(api_client)
        response = api_instance.update_llm_obs_prompt(prompt_id=PROMPT_DATA_ATTRIBUTES_PROMPT_ID, body=body)
    
        print(response)
    

    Instructions

    First install the library and its dependencies and then save the example to example.py and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
    # Update an LLM Observability prompt returns "OK" response
    
    require "datadog_api_client"
    DatadogAPIClient.configure do |config|
      config.unstable_operations["v2.update_llm_obs_prompt".to_sym] = true
    end
    api_instance = DatadogAPIClient::V2::LLMObservabilityAPI.new
    
    # there is a valid "prompt" in the system
    PROMPT_DATA_ATTRIBUTES_PROMPT_ID = ENV["PROMPT_DATA_ATTRIBUTES_PROMPT_ID"]
    
    body = DatadogAPIClient::V2::LLMObsUpdatePromptRequest.new({
      data: DatadogAPIClient::V2::LLMObsUpdatePromptData.new({
        attributes: DatadogAPIClient::V2::LLMObsUpdatePromptDataAttributes.new({
          title: "Customer Support Assistant",
        }),
        type: DatadogAPIClient::V2::LLMObsPromptType::PROMPT_TEMPLATES,
      }),
    })
    p api_instance.update_llm_obs_prompt(PROMPT_DATA_ATTRIBUTES_PROMPT_ID, body)
    

    Instructions

    First install the library and its dependencies and then save the example to example.rb and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
    // Update an LLM Observability prompt returns "OK" response
    use datadog_api_client::datadog;
    use datadog_api_client::datadogV2::api_llm_observability::LLMObservabilityAPI;
    use datadog_api_client::datadogV2::model::LLMObsPromptType;
    use datadog_api_client::datadogV2::model::LLMObsUpdatePromptData;
    use datadog_api_client::datadogV2::model::LLMObsUpdatePromptDataAttributes;
    use datadog_api_client::datadogV2::model::LLMObsUpdatePromptRequest;
    
    #[tokio::main]
    async fn main() {
        // there is a valid "prompt" in the system
        let prompt_data_attributes_prompt_id =
            std::env::var("PROMPT_DATA_ATTRIBUTES_PROMPT_ID").unwrap();
        let body = LLMObsUpdatePromptRequest::new(LLMObsUpdatePromptData::new(
            LLMObsUpdatePromptDataAttributes::new().title("Customer Support Assistant".to_string()),
            LLMObsPromptType::PROMPT_TEMPLATES,
        ));
        let mut configuration = datadog::Configuration::new();
        configuration.set_unstable_operation_enabled("v2.UpdateLLMObsPrompt", true);
        let api = LLMObservabilityAPI::with_config(configuration);
        let resp = api
            .update_llm_obs_prompt(prompt_data_attributes_prompt_id.clone(), body)
            .await;
        if let Ok(value) = resp {
            println!("{:#?}", value);
        } else {
            println!("{:#?}", resp.unwrap_err());
        }
    }
    

    Instructions

    First install the library and its dependencies and then save the example to src/main.rs and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
    /**
     * Update an LLM Observability prompt returns "OK" response
     */
    
    import { client, v2 } from "@datadog/datadog-api-client";
    
    const configuration = client.createConfiguration();
    configuration.unstableOperations["v2.updateLLMObsPrompt"] = true;
    const apiInstance = new v2.LLMObservabilityApi(configuration);
    
    // there is a valid "prompt" in the system
    const PROMPT_DATA_ATTRIBUTES_PROMPT_ID = process.env
      .PROMPT_DATA_ATTRIBUTES_PROMPT_ID as string;
    
    const params: v2.LLMObservabilityApiUpdateLLMObsPromptRequest = {
      body: {
        data: {
          attributes: {
            title: "Customer Support Assistant",
          },
          type: "prompt-templates",
        },
      },
      promptId: PROMPT_DATA_ATTRIBUTES_PROMPT_ID,
    };
    
    apiInstance
      .updateLLMObsPrompt(params)
      .then((data: v2.LLMObsPromptResponse) => {
        console.log(
          "API called successfully. Returned data: " + JSON.stringify(data)
        );
      })
      .catch((error: any) => console.error(error));
    

    Instructions

    First install the library and its dependencies and then save the example to example.ts and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"